#pragma once

#include "CoreMinimal.h"
#include "BasicChargeableInteraction.h"
#include "DBDTunableRowHandle.h"
#include "K06ChargeSpecialPounceAttackInteraction.generated.h"

class UCurveFloat;
class ADBDPlayer;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class THESHAPE_API UK06ChargeSpecialPounceAttackInteraction : public UBasicChargeableInteraction
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	UCurveFloat* _chargingMovementSpeedCurve;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _minimumChargePercentToTriggerAttack;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _cancelCooldownTime;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_ReachedMinimumChargeTime, meta=(AllowPrivateAccess=true))
	bool _reachedMinimumChargeTime;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	ADBDPlayer* _owningPlayer;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_ReachedMinimumChargeTime();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UK06ChargeSpecialPounceAttackInteraction();
};

FORCEINLINE uint32 GetTypeHash(const UK06ChargeSpecialPounceAttackInteraction) { return 0; }
